/* intvec.h Generated automatically by Makefile. */
#ifndef intvec_h_INCLUDED
#define intvec_h_INCLUDED
/* config.h.  Generated automatically by configure.  */
/* config.h.in.  Generated automatically from configure.in by autoheader.  */

/* Define if using alloca.c.  */
/* #undef C_ALLOCA */

/* Define to empty if the keyword does not work.  */
/* #undef const */

/* Define to one of _getb67, GETB67, getb67 for Cray-2 and Cray-YMP systems.
   This function is required for alloca.c support on those systems.  */
/* #undef CRAY_STACKSEG_END */

/* Define if you have alloca, as a function or macro.  */
#define INTV_HAVE_ALLOCA 1

/* Define if you have <alloca.h> and it should be used (not on Ultrix).  */
#define INTV_HAVE_ALLOCA_H 1

/* Define as __inline if that's what the C compiler calls it.  */
/* #undef inline */

/* Define to `unsigned' if <sys/types.h> doesn't define.  */
/* #undef size_t */

/* If using the C implementation of alloca, define if you know the
   direction of stack growth for your system; otherwise it will be
   automatically deduced at run-time.
	STACK_DIRECTION > 0 => grows toward higher addresses
	STACK_DIRECTION < 0 => grows toward lower addresses
	STACK_DIRECTION = 0 => direction of growth unknown
 */
/* #undef STACK_DIRECTION */

/* Define if you have the ANSI C header files.  */
#define INTV_STDC_HEADERS 1

/* Define if your processor stores words with the most significant
   byte first (like Motorola and SPARC, unlike Intel and VAX).  */
#define INTV_WORDS_BIGENDIAN 1

/* #undef USING_TOR */
/* #undef USING_PHP */
/* #undef USING_LL */

/* Define if you have the memalign function.  */
#define INTV_HAVE_MEMALIGN 1

/* Define if you have the <limits.h> header file.  */
#define INTV_HAVE_LIMITS_H 1
/* $Header: /u/spert/src/intvec/RCS/intv-defs.h,v 1.7 1996/01/05 00:21:59 davidj Exp $ */

/* Work out how to find alloca - see the autoconf docs for more details */
#ifdef __GNUC__
#define alloca __builtin_alloca
#else
#ifdef INTV_HAVE_ALLOCA_H
#include <alloca.h>
#endif
#endif

#ifndef INTV_BITS_CHAR
#define INTV_BITS_CHAR (8)
#endif

#ifndef INTV_BITS_SHORT
#define INTV_BITS_SHORT (16)
#endif

#ifndef INTV_BITS_INT
#define INTV_BITS_INT (32)
#endif

#if (INTV_BITS_CHAR==8)
# if defined(__STDC__) || defined(__cplusplus)
typedef signed char intv_int8_t;
# else
typedef char intv_int8_t;
# endif
typedef unsigned char intv_uint8_t;
#else
#error We need an 8 bit type
#endif

#if (INTV_BITS_SHORT==16)
typedef short intv_int16_t;
typedef unsigned short intv_uint16_t;
#else
#error We need a 16 bit type
#endif

#if (INTV_BITS_INT==32)
typedef int intv_int32_t;
typedef unsigned int intv_uint32_t;
#else
#error We need a 32 bit type
#endif

typedef int intv_bool_t;
#define INTV_FALSE (0)
#define INTV_TRUE (1)

#define INTV_SIZET_BAD (0xfffffffful)

#define INTV_INT8_MIN (-0x80)
#define INTV_INT8_MAX (0x7f)
#define INTV_INT16_MIN (-0x8000)
#define INTV_INT16_MAX (0x7fff)
#define INTV_INT32_MIN (-0x7fffffff-1)
#define INTV_INT32_MAX (0x7fffffff)


/****************************************************************/
/* Convert native to/from big/little endian */

#ifdef INTV_WORDS_BIGENDIAN
#define htob_i32_i32(val) (val)
#define htob_vi32_vi32(len, in, out) copy_vi32_vi32(len, in, out)
#define htol_i32_i32(val) swapb_i32_i32(val)
#define htol_vi32_vi32(len, in, out) swapb_vi32_vi32(len, in, out)
#define btoh_i32_i32(val) (val)
#define btoh_vi32_vi32(len, in, out) copy_vi32_vi32(len, in, out)
#define ltoh_i32_i32(val) swapb_i32_i32(val)
#define ltoh_vi32_vi32(len, in, out) swapb_vi32_vi32(len, in, out)

#define htob_i16_i16(val) (val)
#define htob_vi16_vi16(len, in, out) copy_vi16_vi16(len, in, out)
#define htol_i16_i16(val) swapb_i16_i16(val)
#define htol_vi16_vi16(len, in, out) swapb_vi16_vi16(len, in, out)
#define btoh_i16_i16(val) (val)
#define btoh_vi16_vi16(len, in, out) copy_vi16_vi16(len, in, out)
#define ltoh_i16_i16(val) swapb_i16_i16(val)
#define ltoh_vi16_vi16(len, in, out) swapb_vi16_vi16(len, in, out)

#else

#define htob_i32_i32(val) swapb_i32_i32(val)
#define htob_vi32_vi32(len, in, out) swapb_vi32_vi32(len, in, out)
#define htol_i32_i32(val) (val)
#define htol_vi32_vi32(len, in, out) copy_vi32_vi32(len, in, out)
#define btoh_i32_i32(val) swapb_i32_i32(val)
#define btoh_vi32_vi32(len, in, out) swapb_vi32_vi32(len, in, out)
#define ltoh_i32_i32(val) (val)
#define ltoh_vi32_vi32(len, in, out) copy_vi32_vi32(len, in, out)

#define htob_i16_i16(val) swapb_i16_i16(val)
#define htob_vi16_vi16(len, in, out) swapb_vi16_vi16(len, in, out)
#define htol_i16_i16(val) (val)
#define htol_vi16_vi16(len, in, out) copy_vi16_vi16(len, in, out)
#define btoh_i16_i16(val) swapb_i16_i16(val)
#define btoh_vi16_vi16(len, in, out) swapb_vi16_vi16(len, in, out)
#define ltoh_i16_i16(val) (val)
#define ltoh_vi16_vi16(len, in, out) copy_vi16_vi16(len, in, out)

#endif

/*** Header created by intvec-scansrc.perl - do not edit ***/

#ifdef __cplusplus
extern "C" {
#endif

intv_int32_t nv_abs_i32_i32(intv_int32_t val);
void nv_abs_vi32_vi32(size_t len, const intv_int32_t* from, intv_int32_t* to);
void nv_add_vi32i32_vi32(size_t len, const intv_int32_t* a, intv_int32_t b,
			 intv_int32_t* res);
void nv_add_vi32vi32_vi32(size_t len, const intv_int32_t* a,
			  const intv_int32_t* b, intv_int32_t* res);
void nv_conv_vi16_vi32(size_t len, const intv_int16_t* from, intv_int32_t* to);
void nv_copy_i16_vi16(size_t len, intv_int16_t from, intv_int16_t* to);
void nv_copy_i32_vi32(size_t len, intv_int32_t from, intv_int32_t* to);
void nv_copy_i8_vi8(size_t len, intv_int8_t from, intv_int8_t* to);
void nv_copy_svi16_vi16(size_t len, size_t stride, const intv_int16_t* from,
			intv_int16_t* to);
void nv_copy_vi16_svi16(size_t len, size_t stride, const intv_int16_t* from,
			intv_int16_t* to);
void nv_copy_vi16_vi16(size_t len, const intv_int16_t* from, intv_int16_t* to);
void nv_copy_vi32_vi32(size_t len, const intv_int32_t* from, intv_int32_t* to);
void nv_copy_vi8_vi8(size_t len, const intv_int8_t* from, intv_int8_t* to);
intv_int32_t nv_countlo_i32_i32(intv_int32_t val);
intv_int32_t nv_countls_i32_i32(intv_int32_t val);
intv_int32_t nv_countlz_i32_i32(intv_int32_t val);
void nv_countlz_vi32_vi32(size_t len, const intv_int32_t* in,
			  intv_int32_t* res);
void nv_div_i32vi32_vi32(size_t len, intv_int32_t a, const intv_int32_t* b,
			 intv_int32_t* res);
void nv_div_vi32i32_vi32(size_t len, const intv_int32_t* a, intv_int32_t b,
			 intv_int32_t* res);
void nv_div_vi32vi32_vi32(size_t len, const intv_int32_t* a,
			  const intv_int32_t* b, intv_int32_t* res);
# ifdef INTV_HAVE_ALLOCA
#   define nv_falloc_vi16(len) \
        ((intv_int16_t *) alloca((len) * sizeof(intv_int16_t)))
# else
#   define nv_falloc_vi16(len) \
        ((intv_int16_t *) intv_malloc((len) * sizeof(intv_int16_t)))
# endif
# ifdef INTV_HAVE_ALLOCA
#   define nv_falloc_vi32(len) \
        ((intv_int32_t *) alloca((len) * sizeof(intv_int32_t)))
# else
#   define nv_falloc_vi32(len) \
        ((intv_int32_t *) intv_malloc((len) * sizeof(intv_int32_t)))
# endif
# ifdef INTV_HAVE_ALLOCA
#   define nv_falloc_vi8(len) ((intv_int8_t *) alloca((len) * sizeof(intv_int8_t)))
# else
#   define nv_falloc_vi8(len) \
        ((intv_int8_t *) intv_malloc((len) * sizeof(intv_int8_t)))
# endif
# ifdef INTV_HAVE_ALLOCA
#  define nv_ffree_vi16(ptr)
# else
#  define nv_ffree_vi16(ptr) intv_free((ptr))
# endif
# ifdef INTV_HAVE_ALLOCA
#  define nv_ffree_vi32(ptr)
# else
#  define nv_ffree_vi32(ptr) intv_free((ptr))
# endif
#define nv_free_vi16(ptr) intv_free((void *) (ptr))
#define nv_free_vi32(ptr) intv_free((void *) (ptr))
#define nv_free_vi8(ptr) intv_free((void *) (ptr))
void nv_intv_free(void* ptr);
void* nv_intv_malloc(size_t size);
void* nv_intv_memalign(size_t alignment, size_t size);
void* nv_intv_realloc(void* ptr, size_t size);
#define nv_malloc_vi16(len) \
    ((intv_int16_t *) intv_malloc((len) * sizeof(intv_int16_t)))
#define nv_malloc_vi32(len) \
    ((intv_int32_t *) intv_malloc((len) * sizeof(intv_int32_t)))
#define nv_malloc_vi8(len) \
    ((intv_int8_t *) intv_malloc((len) * sizeof(intv_int16_t)))
void nv_mul_vi32i32_vi32(size_t len, const intv_int32_t* a, intv_int32_t b,
			 intv_int32_t* res);
void nv_mul_vi32vi32_vi32(size_t len, const intv_int32_t* a,
			  const intv_int32_t* b, intv_int32_t* res);
intv_int32_t nv_neg_i32_i32(intv_int32_t val);
void nv_neg_vi32_vi32(size_t len, const intv_int32_t* from, intv_int32_t* to);
#define nv_realloc_vi16(ptr, len) \
    ((intv_int16_t *) intv_realloc((void *)(ptr), (len)*sizeof(intv_int16_t)))
#define nv_realloc_vi32(ptr, len) \
    ((intv_int32_t *) intv_realloc((void *) (ptr), (len)*sizeof(intv_int32_t)))
#define nv_realloc_vi8(ptr, len) \
    ((intv_int8_t *) intv_realloc((void *)(ptr), (len)*sizeof(intv_int8_t)))
intv_int32_t nv_satabs_i32_i32(intv_int32_t val);
void nv_satabs_vi32_vi32(size_t len, const intv_int32_t* from,
			 intv_int32_t* to);
intv_int32_t nv_satadd_i32i32_i32(intv_int32_t a, intv_int32_t b);
void nv_satadd_vi32i32_vi32(size_t len, const intv_int32_t* a, intv_int32_t b,
			 intv_int32_t* res);
void nv_satadd_vi32vi32_vi32(size_t len, const intv_int32_t* a,
			  const intv_int32_t* b, intv_int32_t* res);
intv_int32_t nv_satneg_i32_i32(intv_int32_t val);
void nv_satneg_vi32_vi32(size_t len, const intv_int32_t* from,
			 intv_int32_t* to);
intv_int32_t nv_satsub_i32i32_i32(intv_int32_t a, intv_int32_t b);
void nv_satsub_i32vi32_vi32(size_t len, intv_int32_t a, const intv_int32_t* b,
			 intv_int32_t* res);
void nv_satsub_vi32i32_vi32(size_t len, const intv_int32_t* a, intv_int32_t b,
			 intv_int32_t* res);
void nv_satsub_vi32vi32_vi32(size_t len, const intv_int32_t* a,
			  const intv_int32_t* b, intv_int32_t* res);
intv_int16_t nv_sll_i16i32_i16(intv_int16_t val, intv_int32_t lshift);
intv_int32_t nv_sll_i32i32_i32(intv_int32_t val, int lshift);
intv_int16_t nv_sls_i16i32_i16(intv_int16_t val, intv_int32_t lshift);
intv_int32_t nv_sls_i32i32_i32(intv_int32_t val, int lshift);
intv_int16_t nv_srr_i16i32_i16(intv_int16_t val, intv_int32_t rshift);
intv_int32_t nv_srr_i32i32_i32(intv_int32_t val, int rshift);
intv_int16_t nv_srt_i16i32_i16(intv_int16_t a, intv_int32_t rshift);
intv_int32_t nv_srt_i32i32_i32(intv_int32_t a, int rshift);
void nv_sub_i32vi32_vi32(size_t len, intv_int32_t a, const intv_int32_t* b,
			 intv_int32_t* res);
void nv_sub_vi32i32_vi32(size_t len, const intv_int32_t* a, intv_int32_t b,
			 intv_int32_t* res);
void nv_sub_vi32vi32_vi32(size_t len, const intv_int32_t* a,
			  const intv_int32_t* b, intv_int32_t* res);
intv_int32_t nv_sum_vi32_i32(size_t len, const intv_int32_t* in);
intv_int16_t nv_swapb_i16_i16(intv_int16_t val);
intv_int32_t nv_swapb_i32_i32(intv_int32_t val);
void nv_swapb_vi16_vi16(size_t len, const intv_int16_t* from,
			intv_int16_t* to);
void nv_swapb_vi32_vi32(size_t len, const intv_int32_t* from,
			intv_int32_t* to);
void nv_trans_mi16_mi16(size_t in_height, size_t in_width,
			const intv_int16_t* in, intv_int16_t* res);

#ifdef __cplusplus
}
#endif

#define abs_i32_i32 nv_abs_i32_i32
#define swapb_i32_i32 nv_swapb_i32_i32
#define realloc_vi16 nv_realloc_vi16
#define copy_vi32_vi32 nv_copy_vi32_vi32
#define satsub_i32i32_i32 nv_satsub_i32i32_i32
#define satabs_i32_i32 nv_satabs_i32_i32
#define sub_vi32vi32_vi32 nv_sub_vi32vi32_vi32
#define falloc_vi32 nv_falloc_vi32
#define srt_i32i32_i32 nv_srt_i32i32_i32
#define free_vi16 nv_free_vi16
#define mul_vi32vi32_vi32 nv_mul_vi32vi32_vi32
#define add_vi32vi32_vi32 nv_add_vi32vi32_vi32
#define satadd_vi32i32_vi32 nv_satadd_vi32i32_vi32
#define malloc_vi8 nv_malloc_vi8
#define realloc_vi32 nv_realloc_vi32
#define neg_i32_i32 nv_neg_i32_i32
#define free_vi32 nv_free_vi32
#define ffree_vi16 nv_ffree_vi16
#define free_vi8 nv_free_vi8
#define countlo_i32_i32 nv_countlo_i32_i32
#define copy_vi16_vi16 nv_copy_vi16_vi16
#define swapb_vi32_vi32 nv_swapb_vi32_vi32
#define sll_i32i32_i32 nv_sll_i32i32_i32
#define satsub_vi32i32_vi32 nv_satsub_vi32i32_vi32
#define satneg_i32_i32 nv_satneg_i32_i32
#define mul_vi32i32_vi32 nv_mul_vi32i32_vi32
#define copy_i16_vi16 nv_copy_i16_vi16
#define copy_vi8_vi8 nv_copy_vi8_vi8
#define sls_i16i32_i16 nv_sls_i16i32_i16
#define abs_vi32_vi32 nv_abs_vi32_vi32
#define neg_vi32_vi32 nv_neg_vi32_vi32
#define falloc_vi16 nv_falloc_vi16
#define copy_svi16_vi16 nv_copy_svi16_vi16
#define sum_vi32_i32 nv_sum_vi32_i32
#define srr_i16i32_i16 nv_srr_i16i32_i16
#define intv_malloc nv_intv_malloc
#define div_vi32i32_vi32 nv_div_vi32i32_vi32
#define realloc_vi8 nv_realloc_vi8
#define intv_realloc nv_intv_realloc
#define div_i32vi32_vi32 nv_div_i32vi32_vi32
#define trans_mi16_mi16 nv_trans_mi16_mi16
#define sub_vi32i32_vi32 nv_sub_vi32i32_vi32
#define satsub_i32vi32_vi32 nv_satsub_i32vi32_vi32
#define add_vi32i32_vi32 nv_add_vi32i32_vi32
#define malloc_vi32 nv_malloc_vi32
#define sub_i32vi32_vi32 nv_sub_i32vi32_vi32
#define countlz_i32_i32 nv_countlz_i32_i32
#define swapb_i16_i16 nv_swapb_i16_i16
#define srt_i16i32_i16 nv_srt_i16i32_i16
#define satneg_vi32_vi32 nv_satneg_vi32_vi32
#define conv_vi16_vi32 nv_conv_vi16_vi32
#define copy_i32_vi32 nv_copy_i32_vi32
#define intv_memalign nv_intv_memalign
#define countlz_vi32_vi32 nv_countlz_vi32_vi32
#define ffree_vi32 nv_ffree_vi32
#define satsub_vi32vi32_vi32 nv_satsub_vi32vi32_vi32
#define satabs_vi32_vi32 nv_satabs_vi32_vi32
#define sll_i16i32_i16 nv_sll_i16i32_i16
#define copy_i8_vi8 nv_copy_i8_vi8
#define div_vi32vi32_vi32 nv_div_vi32vi32_vi32
#define countls_i32_i32 nv_countls_i32_i32
#define sls_i32i32_i32 nv_sls_i32i32_i32
#define copy_vi16_svi16 nv_copy_vi16_svi16
#define intv_free nv_intv_free
#define falloc_vi8 nv_falloc_vi8
#define malloc_vi16 nv_malloc_vi16
#define swapb_vi16_vi16 nv_swapb_vi16_vi16
#define srr_i32i32_i32 nv_srr_i32i32_i32
#define satadd_vi32vi32_vi32 nv_satadd_vi32vi32_vi32
#define satadd_i32i32_i32 nv_satadd_i32i32_i32
#endif /* intvec_h_INCLUDED */
