/*
** $Header: /u/spert/src/spert-hdrs/RCS/sysspert.h,v 1.4 1996/08/14 02:19:22 davidj Exp $
**
** SPERT version of sys/sysspert.h definitions that are used by both the
** server and newlib
**
** davidj - Fri Oct 27 17:48:25 1995
*/

#ifndef __SYS_SYSSPRT_H
#define __SYS_SYSSPRT_H

/* This header file handles the sysspert() and sysmiscproc() system
   calls.  The first is for SPERT-specific functions, the second
   for compatibility with other operating systems.
*/

/*** sysspert() constants ***/

/* Note - cannot use "" in constant names (except as prefix),
   as will be editted out */

/* Return the frequency of the cycle counter in MHz */
#define SYSSPRT_VCOUNTFREQ (1)

/*** sysmiscproc() constants ***/

/* Return the page size */
#define SYSMISCPROC_PGSIZE (14)
/* Return the address to use for the device driver and host/spert messaging */
#define SYSMISCPROC_MESSMEM (101)

#endif
