/*
** $Header: /u/spert/src/newlib/newlib/libc/machine/torrent/machine/RCS/tordef.h,v 1.2 1995/10/31 21:02:21 davidj Exp $
**
** Torrent specific assembler definitions
**
** davidj - Tue Jun  1 12:16:22 1993
*/

#ifndef TORDEF_H_INCLUDED
#define TORDEF_H_INCLUDED

#include <machine/regdef.h>
#include <machine/t0def.h>
#include <machine/configreg.h>

/* NOTE:
** This file contains definitions for user-mode torrent assembler code -
** system level register names and constants are stored elsewhere
*/


/* Coprocessor two control registers */

/* Old names - DO NOT USE ANY MORE */

#define VREV $0
#define VCOUNT $1
#define VLR $2
#define VCOND $4
#define VOVF $8
#define VSAT $12

/* These are the names to use now! */

#define vrev $0
#define vcount $1
#define vlr $2
#define vcond $4
#define vovf $8
#define vsat $12

/* Vector unit registers */

#define vzero $vr0
#define vv0 $vr0
#define vv1 $vr1
#define vv2 $vr2
#define vv3 $vr3
#define vv4 $vr4
#define vv5 $vr5
#define vv6 $vr6
#define vv7 $vr7
#define vv8 $vr8
#define vv9 $vr9
#define vv10 $vr10
#define vv11 $vr11
#define vv12 $vr12
#define vv13 $vr13
/*
These registers are reserved for system use in CNS-0/CNS-1

#define vv14 $vr14
#define vv15 $vr15
*/

#endif /* #ifndef TORDEF_H_INCLUDED */




